package com.acme;

import static org.assertj.core.api.Assertions.assertThat;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.context.SpringBootTest.WebEnvironment;

@SpringBootTest(webEnvironment = WebEnvironment.NONE)
public class PointcutTests {

	@Autowired
	PersonRepository repository;

	@Test
	public void testPositivePointcut() {
		Person person = repository.save(new Person("firstname1", "lastname1"));
		assertThat(repository.findByFirstname(person.getFirstname())).hasSize(1);
	}

	@Test
	public void testNegativePointcut() {
		Person person = repository.save(new Person("firstname2", "lastname2"));
		assertThat(repository.findByLastname(person.getLastname())).hasSize(1); // exception thrown

	}

}
