package com.acme;

import java.lang.reflect.Method;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.reflect.MethodSignature;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

@Aspect
@Component
public class SimpleAspect {

	@Around("execution(public * *(..)) and target(repository) and @annotation(org.springframework.transaction.annotation.Transactional)")
	public Object interceptPositive(ProceedingJoinPoint pjp, PersonRepository repository) throws Throwable {
		Method method = ((MethodSignature) pjp.getSignature()).getMethod();
		if (!method.isAnnotationPresent(Transactional.class))
			throw new RuntimeException("annotation should present here");
		return pjp.proceed();
	}

	@Around("execution(public * *(..)) and target(repository) and not @annotation(org.springframework.transaction.annotation.Transactional)")
	public Object interceptNegative(ProceedingJoinPoint pjp, PersonRepository repository) throws Throwable {
		Method method = ((MethodSignature) pjp.getSignature()).getMethod();
		if (method.isAnnotationPresent(Transactional.class))
			throw new RuntimeException("annotation should not present here");
		return pjp.proceed();
	}

}
